import { Input, Card, Button, Space, Image, Row } from 'antd';
import { useEffect, useRef, useState } from 'react';
import { connect } from 'react-redux';
import { InputUpLoadFile } from '.';
import { backURL } from '../api'; 

const { TextArea } = Input;

const CharacterfGood =({ good, good:{ _id, name, description, images, price }, upLoad, changeGood, number, changeIndexGoodInSer }) => {    
    const [ inputIdImg, setInputIdImg] = useState(''); 
    const [ inputName, setInputName ] = useState(name); 
    const [ inputDescrip, setInputDescrip] = useState(description);
    const [ imag, setImag ] = useState(''); 
    const [ cost, setCost ] = useState(price);
    const [inputNumber, setInputNumber] = useState(number);

    useEffect( () => {
      setInputName(name);
      setInputDescrip(description);

      if (images && images[0].url) {
        setImag(images[0].url); 
        setInputIdImg(images[0]._id);
      }

      if (Object.keys(good).length === 0) { console.log('gfergergrthetrhrthyrty')
        setImag(''); 
        setInputIdImg('');
      }
      if(images && !images[0].url) {
        setImag(''); 
        setInputIdImg(''); 
      }
              
      setCost(price); 
      setInputNumber(number); 
          

    }, [good])

    

    useEffect(() => {
      if(upLoad && upLoad.status === 'RESOLVED' ) { 
        setImag(upLoad.payload.url); console.log('39', imag)
        setInputIdImg(upLoad.payload._id);  
      }

    }, [upLoad])

    // onChange = ({ target: { value } }) => {
    //   setInputDescrip(value);
    // };

    const clearInput = () => {
      setInputName('');
      setInputDescrip('');
      setCost('');
      setImag ('');
      setInputIdImg('');

    }

    const saveChange = () => {
      changeGood(inputName, inputDescrip, cost, inputIdImg );
      changeIndexGoodInSer(inputNumber);
      clearInput();
    }
                                                                        console.log('imag', imag); console.log('good',good)
  return (
    <div >
        <div>№ в категории</div>
          <Input value={inputNumber} onChange={(e) => setInputNumber(e.target.value)}/>
          <Button type="primary" onClick={() => setInputNumber('')}>Очистить поле</Button>

      <div>Название</div>
        <Input value={inputName} onChange={(e) => setInputName(e.target.value)}/>
        <Button type="primary" onClick={() => setInputName('')}>Очистить поле</Button>
      <div>Характеристика</div>
        <TextArea
            value={inputDescrip}
            onChange={(e) => setInputDescrip(e.target.value)}
            
            autoSize={{ minRows: 3, maxRows: 5 }}
          />
        <Button type="primary" onClick={() => setInputDescrip('')}>Очистить поле</Button>
      <div>Цена</div>
        <Row>
          <Input value={cost} onChange={(e) => setCost(e.target.value)}/>
          <Button type="primary" onClick={() => setCost('')}>Очистить поле</Button>
        </Row>
       
        
        <Space size={12} direction="vertical">
          
            {/* <div  className="imgWrapper"> */}
              <div>Фото</div>
            {Object.keys(good).length === 0 ?
              <div style={{height:"150px", width:"150px"}}> </div>
              :
              <Image width={150} height={150} src={`${backURL}/${imag}`} style={{ objectFit: 'cover' }}/>}
              <InputUpLoadFile/>
           {/* </div> */}
        </Space>
        <Space size={2}></Space>
        <Button type="primary" block onClick={saveChange}>
          Сохранить изменения
        </Button>     
  </div>
  )
}

const mapStateToProps = ((state) => ({
  upLoad: state.promise?.upLoad
}))
const СhangeOfGood = connect(mapStateToProps)(CharacterfGood);

export default СhangeOfGood;

//{images && images[0] && images[0].url && (src={backURL + '/' + `${img || images[0].url }`})}